#!/usr/local/bin/wish
set HOME $env(HOME)
### default location of dame executable
set DEFAUTDIR $HOME/Jeux
### default executable
set DEFAUTPROG $HOME/Jeux/dames
### Architecture dependant execution of dames program
proc Execute {Programme Fichier Temps} {
    return [exec $Programme $Fichier $Temps]
}
### --------- End of Unix/Linux Code --------- ###


### #!/cygdrive/c/PROGRA~1/TCL/bin/wish82
### # PDAMES
# Time-stamp: <10 Jan 02 17:53:37 Jean-Guillaume.Dumas@imag.fr> 

### ### default location of dame executable
### set DEFAUTDIR C:/PROGRA~1/cygwin/bin
### ### default executable
### set DEFAUTPROG C:/PROGRA~1/cygwin/bin/dames.exe

### ### Architecture dependant execution of dames program
### proc Execute {Programme Fichier Temps} {
###     ### default location of shell
###     set BINDIR C:/PROGRA~1/cygwin/bin
###     return [exec $BINDIR/bash -c "cd $BINDIR;$Programme $Fichier $Temps"]
### }
### --------- End of Windows Code --------- ###


### --------- Generic Code --------- ###

set DEFAUTTIME 1

set JOUEUR -1
set PREVIOUSC 0
set PREVIOUSI 0
set PREVIOUSJ 0
set STRMOVE ""
set LASTMOVE ""
set COMPUTING ""
set LOCAL [file dirname $argv0]

set ORDI 0

set FILE(1) ""
set FILE(-1) ""
set GLOBALTIME(-1) 0
set GLOBALTIME(1) 0
set GLOBALLAST(-1) 0
set GLOBALLAST(1) 0
set NBCOUPS(-1) 0
set NBCOUPS(1) 0

# Absolute value
proc ABS {a} {
    return [expr ($a <0) ? -$a : $a]
}


proc SetProg {num program time} {
    global env ORDI PROG ARGS MAXTIME FILE PLATEAU DEFAUTDIR
    set prog [file join $DEFAUTDIR [file tail $program]]
    if {! [file executable $prog]} {
	set prog $program
    }
    set PROG($num) $prog
    if {! [file executable $PROG($num)]} {
	puts "Erreur : $PROG($num) n'est pas excutable."
	exit
    }
    set ARGS($num) $time

    set t1 [clock clicks]
    after 1000
    set t2 [clock clicks]
    set MAXTIME($num) [expr ([ABS $ARGS($num)]*10+1)*($t2 - $t1)/10]

    set FILE($num) xdam_f$num.jgd
    set PLATEAU [file join $DEFAUTDIR xdam_bo.jgd]

    file delete -force $FILE($num)
    puts "Coups jous par $PROG($num) $ARGS($num) dans \t: $FILE($num)"
    
    set ORDI [expr $ORDI - 1]
}



if {[expr [llength $argv] > 0]} {
    # One prog    
    SetProg 1 [lindex $argv 0] [lindex $argv 1]
    set PREVIOUSC -1
}

if {[expr [llength $argv] > 2]} {
    # Two progs
    SetProg -1 [lindex $argv 2] [lindex $argv 3]
}

set CHANGINCOLOR 0

proc Chooser {color} {
    global CHANGINCOLOR
    set CHANGINCOLOR $color
    toplevel .joueurs
    if {[expr $color == 1]} {
	set textcolor Blancs
    } else {
	set textcolor Noirs
    }
    label .joueurs.lab -text [concat "Les " $textcolor " sont jous par :"] -width 30
    frame .joueurs.ser
    button .joueurs.ser.u -text Mulot -command ChooserUser -width 10
    button .joueurs.ser.p -text Programme -command { ChooserProg $CHANGINCOLOR } -width 10
    pack .joueurs.ser.p .joueurs.ser.u -side left -padx 5
    pack .joueurs.lab .joueurs.ser -side top -pady 5
}

proc ChooserProg {textcolor} {
    global DEFAUTPROG DEFAUTTIME CHANGINCOLOR
    if {[expr $CHANGINCOLOR == 1]} {
        set textcolor Blancs
    } else {
        set textcolor Noirs
    }
    destroy .joueurs
    toplevel .programme
    label .programme.lab -text [concat "Les " $textcolor " sont jous par :"] -width 30
    frame .programme.top
    label .programme.top.l -text Programme -width 15
    entry .programme.top.e -width 30 -bg white -relief sunken -textvariable tope
    frame .programme.mid
    label .programme.mid.l -text Temps -width 15
    entry .programme.mid.t -width 30 -bg white -relief sunken -textvariable midt
    frame .programme.bot
    button .programme.bot.b -text "OK" -command { SetChoice $tope $midt }
    button .programme.bot.v -text "Valeurs" -command { set tope $DEFAUTPROG; set midt $DEFAUTTIME }
    button .programme.bot.d -text "Dfaut" -command { SetChoice $DEFAUTPROG $DEFAUTTIME }
    pack .programme.top.l .programme.top.e -side left
    pack .programme.mid.l .programme.mid.t -side left
    pack .programme.bot.b .programme.bot.v .programme.bot.d -side right -padx 4
    pack .programme.lab .programme.top .programme.mid .programme.bot -side top -pady 4

}
proc ChooserUser {} {
    global CHANGINCOLOR ORDI ARGS
    destroy .joueurs
    if {[expr $ORDI == -1]} {
	set actualone [expr $ARGS(1) / [ABS $ARGS(1)]]
 	if {[expr $actualone == $CHANGINCOLOR]} {
	    set ORDI 0
	}
    } else {
	if {[expr $ORDI == -2]} {
	    set actualone [expr $ARGS(1) / [ABS $ARGS(1)]]
	    if {[expr $actualone == $CHANGINCOLOR]} {
		global FILE PROG ARGS MAXTIME
		set FILE(1) $FILE(-1)
		set PROG(1) $PROG(-1)
		set ARGS(1) $ARGS(-1)
		set MAXTIME(1) $MAXTIME(-1)
	    } 
	    set ORDI -1
	}
    }
    destroy .plateau
    BuildTable
}


proc SetChoice {program time} {
    global CHANGINCOLOR ORDI ARGS
    destroy .programme
    set numprog 1
    if {[expr $ORDI < 0]} {
	set actualone [expr $ARGS(1) / [ABS $ARGS(1)]]
	if {[expr $actualone == $CHANGINCOLOR]} {
	    set ORDI [expr $ORDI + 1]
	    set numprog 1
	} else {
	    set numprog -1
	    if {[expr $ORDI < -1]} {
		set ORDI [expr $ORDI + 1]
	    }
	}
    }

    SetProg $numprog $program [expr $CHANGINCOLOR * [ABS $time]]
    destroy .plateau
    BuildTable
}   

proc Init {} {

    BuildTable
}

# Image size
set IMS    38

# Plateau dimension : 10x10 with 4 rows occupied by each player
set DIM    10
set RAG     4

### Initial Positioms
set lignes(9) "-1 -1 -1 -1 -1"
set lignes(8) "-1 -1 -1 -1 -1"
set lignes(7) "-1 -1 -1 -1 -1"
set lignes(6) "-1 -1 -1 -1 -1"
set lignes(5) "0 0 0 0 0"
set lignes(4) "0 0 0 0 0"
set lignes(3) "1 1 1 1 1"
set lignes(2) "1 1 1 1 1"
set lignes(1) "1 1 1 1 1"
set lignes(0) "1 1 1 1 1"


proc DisplayGame {JOUEUR} {
    global PLATEAU
    global lignes


    set FILEID($JOUEUR) [open $PLATEAU w 0600]
    
    for {set i 9} {[expr $i >= 0]} {incr i -1} {
	set clignes ""
	for {set j 0} {[expr $j < 5]} {incr j} {
	    set val [lindex $lignes($i) $j]
	    switch -- $val {
		-1 {append clignes b}
		1 {append clignes w}
		-2 {append clignes B}
		2 {append clignes W}
		0 {append clignes " "}
	    }
	}

        puts $FILEID($JOUEUR) $clignes
    }

    close $FILEID($JOUEUR)
}


set WHITES 20
set BLACKS 20
set RETARD(1) 0
set RETARD(-1) 0

# Pictures
if {[expr ! [file readable $LOCAL/empty.gif]]} {
    set LOCAL ./
}
# if {[expr ! [file readable $LOCAL/empty.gif]]} {
#     set LOCAL [exec which $argv0]
# }


image create photo CaseVide  -file $LOCAL/empty.gif
image create photo pionB -file $LOCAL/ymw.gif
image create photo pionN -file $LOCAL/ymb.gif
image create photo dameB -file $LOCAL/ykw.gif
image create photo dameN -file $LOCAL/ykb.gif
set OBJET "dameN pionN CaseVide pionB dameB"

# Colors
proc GeneralBG {} { return \#0000A0 }
#proc ButtonBG {} { return \#A0A0FF }
proc ButtonBG {} { return \#0000A0 }
proc EmptyBG {} { return \#A0A0FF }
proc PressedBG {} { return \#FF0000 }
proc FocusBG {} { return orange } 
proc PlateauBG {} { return \#007070 }
# proc MButtonBG {} { return \#C080D0 }
# proc MButtonHBG {} { return \#9050B0 }
# proc MButtonABG {} { return \#8080FF }
proc MButtonBG {} { return \#FFFF00 }
proc MButtonHBG {} { return \#FFFF00 }
# orange == FFA000
proc MButtonABG {} { return \#FFA000 }

# Squaress and Pawns
proc BuildBoard {} {
    global IMS
    global DIM
    global EXTRA
    for {set i 0} {[expr $i < $DIM]} {incr i} {
	frame .plateau.r$i -height $IMS -width [expr $IMS * $DIM] -background [PlateauBG] -highlightbackground [PlateauBG] 
	canvas .plateau.r$i.canel -height $EXTRA -width $EXTRA -background [PlateauBG] -highlightbackground [PlateauBG] 
	pack .plateau.r$i.canel -side left
	.plateau.r$i.canel create text 13 12 -text $i -fill white
	for {set j 0} {[expr $j < $DIM]} {incr j} {
	    if {($i+$j)%2} { 
#		canvas .plateau.r$i.c$i$j -height $IMS -width $IMS -highlightbackground black -background [GeneralBG] -borderwidth 0
		canvas .plateau.r$i.c$i$j -height $IMS -width $IMS -highlightbackground black -background [EmptyBG] -borderwidth 0
		pack .plateau.r$i.c$i$j -side left
	    } else { 
		button .plateau.r$i.b$i$j -anchor e -image [sState [nState $i $j] ] -activebackground [FocusBG] -highlightbackground black -background [ButtonBG] -borderwidth 0 -command "if \{\[Select $i $j\]\} \{ Next \}"
		pack .plateau.r$i.b$i$j -side left
	    }	       
	}
	canvas .plateau.r$i.caner -height $EXTRA -width $EXTRA -background [PlateauBG] -highlightbackground [PlateauBG] 
	pack .plateau.r$i.caner -side left
	.plateau.r$i.caner create text 9 12 -text $i -fill white
	pack .plateau.r$i -side bottom
    }
    
	    
}

## Packs start and exit buttons
proc BuildTable {} {
    global DIM
    global IMS
    global EXTRA
    frame .plateau -background [PlateauBG]
    frame  .plateau.frame -height $IMS -width [expr ($IMS * $DIM)]  -background [PlateauBG]
    for {set i 0} {[expr $i < $DIM]} {incr i} {
	set let [charCol $i]
	canvas .plateau.frame.can$let -height $EXTRA -width $IMS  -background [PlateauBG] -highlightbackground [PlateauBG] 
	pack .plateau.frame.can$let -side left
	.plateau.frame.can$let create text 19 9 -text $let -fill white
    }
    pack .plateau.frame -side bottom

    BuildBoard
    frame  .plateau.frameb -height $IMS -width [expr $IMS * $DIM] -background [PlateauBG] -highlightbackground [PlateauBG]
    for {set i 0} {[expr $i < $DIM]} {incr i} {
	set let [charCol $i]
	canvas .plateau.frameb.can$let -height 25 -width $IMS -background [PlateauBG] -highlightbackground [PlateauBG]
	pack .plateau.frameb.can$let -side left
	.plateau.frameb.can$let create text 19 17 -text $let -fill white
    }
    pack .plateau.frameb -side bottom

    frame  .plateau.diff -height 1 -width [expr $IMS * $DIM]  -background [PlateauBG]
    frame  .plateau.diff.fr -height 10 -width 40  -background [PlateauBG]
    button  .plateau.diff.bla -text " Blancs " -background white -foreground black -width 9 -relief flat -command {Chooser 1}
    button  .plateau.diff.noi -text "  Noirs " -background black -foreground white -width 9  -relief flat -command {Chooser -1}
    label  .plateau.diff.ncs -textvariable WHITES -background white -foreground black -width 3 -borderwidth 7
    label  .plateau.diff.rs -textvariable BLACKS -background black -foreground white -width 3 -borderwidth 7

    global ORDI
    if {$ORDI} {
	label  .plateau.diff.blaret -text " retards" -background white -foreground black -width 8 -borderwidth 7
	label  .plateau.diff.noiret -text " retards" -background black -foreground white -width 8 -borderwidth 7
	label  .plateau.diff.ncsret -textvariable RETARD(1) -background white -foreground black -width 4 -borderwidth 7
	label  .plateau.diff.rsret -textvariable RETARD(-1) -background black -foreground white -width 4 -borderwidth 7
	if {[expr $ORDI == -2]} {    
	    pack .plateau.diff.noiret .plateau.diff.rsret .plateau.diff.noi .plateau.diff.rs .plateau.diff.fr -side right -padx 2
	    pack .plateau.diff.ncs .plateau.diff.bla .plateau.diff.ncsret .plateau.diff.blaret -side left -padx 2


    frame  .plateau.time -height 1 -width [expr $IMS * $DIM]  -background [PlateauBG]
    frame  .plateau.time.fr -height 10 -width 40  -background [PlateauBG]
    label  .plateau.time.ncs -text " Temps global : " -background white -foreground black -width 16
    label  .plateau.time.rs -text " Temps global : " -background black -foreground white -width 16
    label  .plateau.time.bla -textvariable GLOBALTIME(1) -background white -foreground black -width 10
    label  .plateau.time.noi -textvariable GLOBALTIME(-1) -background black -foreground white -width 10
    pack .plateau.time.noi .plateau.time.rs .plateau.time.fr -side right
    pack .plateau.time.ncs .plateau.time.bla -side left
    pack .plateau.time -side bottom

    frame  .plateau.last -height 1 -width [expr $IMS * $DIM]  -background [PlateauBG]
    frame  .plateau.last.fr -height 10 -width 40  -background [PlateauBG]
    label  .plateau.last.ncs -text "Dernier temps : " -background white -foreground black -width 16
    label  .plateau.last.rs -text "Dernier temps : " -background black -foreground white -width 16
    label  .plateau.last.bla -textvariable GLOBALLAST(1) -background white -foreground black -width 10
    label  .plateau.last.noi -textvariable GLOBALLAST(-1) -background black -foreground white -width 10
    pack .plateau.last.noi .plateau.last.rs .plateau.last.fr -side right
    pack .plateau.last.ncs .plateau.last.bla -side left
    pack .plateau.last -side bottom
    

	} else {
	    global ARGS
	    .plateau.diff.fr configure -width 200
	    if {[expr $ARGS(1)>0]} {
		## Whites
		pack .plateau.diff.noi .plateau.diff.rs .plateau.diff.fr -side right -padx 2
		pack .plateau.diff.ncs .plateau.diff.bla .plateau.diff.ncsret .plateau.diff.blaret -side left -padx 2
	    } else {
		## blacks
		.plateau.diff.rsret configure -textvariable RETARD(1)
		pack .plateau.diff.noiret .plateau.diff.rsret .plateau.diff.noi .plateau.diff.rs .plateau.diff.fr -side right -padx 2
		pack .plateau.diff.ncs .plateau.diff.bla -side left -padx 2
	    }
	}
    } else {
	.plateau.diff.fr configure -width 280
	pack .plateau.diff.noi .plateau.diff.rs .plateau.diff.fr -side right  -padx 2
	pack .plateau.diff.ncs .plateau.diff.bla -side left -padx 2
    }
	
    pack .plateau.diff -side bottom
    
    button .plateau.exit -text "Exit" -command { Quit "Exit"; exit } -background [MButtonBG] -highlightbackground [MButtonHBG] -activebackground [MButtonABG] 
    button .plateau.start -text "Start" -command {Start} -background [MButtonBG] -highlightbackground [MButtonHBG] -activebackground [MButtonABG] 
    label  .plateau.text -text "Dernier coup jou : " -foreground white -background [PlateauBG] 
    label  .plateau.coup -textvariable LASTMOVE -foreground red -background [PlateauBG] 
    label  .plateau.comp -textvariable COMPUTING -foreground red -background [PlateauBG] -relief sunken -width 11
    pack .plateau.exit .plateau.comp -side right -padx 10 -pady 10 
    pack .plateau.start -side left -padx 10 -pady 10
    pack .plateau.text .plateau.coup -side left
    

    pack .plateau
}

proc Start {} {
    global OVER; set OVER 0
    Next
}

# Removes squares
proc Destroy {} {
    global DIM
    for {set i 0} {[expr $i < $DIM]} {incr i} {
	for {set j 0} {[expr $j < $DIM]} {incr j} {
	    if {($i+$j)%2} { 
		destroy .plateau.r$i.c$i$j
	    } else { 
		destroy .plateau.r$i.b$i$j
	    }	       
	}
	destroy .plateau.r$i
    }	    
}



# Square state : pawn, queen (with color), or empty
proc nState {i j} {
 global lignes
 return  [lindex $lignes($i) [expr $j/2] ]  
}

# Sets square state
proc setState {i j col} {
    global lignes
    global BLACKS
    global WHITES
    set previous [nState $i $j]
    if {[expr ($previous > 0)]} {
	incr WHITES -1
    }
    if {[expr ($previous < 0)]} {
	incr BLACKS -1
    }
    .plateau.r$i.b$i$j configure -image [sState $col] -background [ButtonBG]
    set lignes($i) [lreplace $lignes($i) [expr $j/2] [expr $j/2] $col]
    if {[expr $col>0]} {
	incr WHITES
    }
    if {[expr $col<0]} {
	incr BLACKS
    }
}

# Testing squares
proc isempty {i j} {
    set state [nState $i $j]
    return [expr ($state == 0)]
}
proc isfull {i j} {
    set state [nState $i $j]
    return $state
}

# Testing pieces
proc arefriend {x y} {
    return [expr  (( ($x<0) && ($y<0) ) || ( ($x>0) && ($y>0) )) ]
}

proc arenemies {x y} {
    return [expr  (( ($x<0) && ($y>0) ) || ( ($x>0) && ($y<0) )) ]
}

# Associate picture to piece
proc sState {type} {
    global OBJET
    return [lindex $OBJET [expr $type+2 ] ]
}

# Button is clicked
proc Select {i j} {
    global PREVIOUSC
    global PREVIOUSI
    global PREVIOUSJ
    global STRMOVE
    set coup [nState $i $j]
    set FINCOUP 0

    if {[expr $PREVIOUSC != 0]} {
	if {[expr $coup != 0]} {
	    ### Not a move
	    .plateau.r$i.b$i$j configure -background [PressedBG]
	    .plateau.r$PREVIOUSI.b$PREVIOUSI$PREVIOUSJ configure -background [ButtonBG]
	    if {[expr ( ($PREVIOUSI == $i) && ($PREVIOUSJ == $j) )]} {
		## click is same place as before
		if {[expr ([string length $STRMOVE] > 0)]} { 
		    # It means that it is the end of a jump
		    set STRMOVE "$STRMOVE[charCol $PREVIOUSJ]$PREVIOUSI"
		    set FINCOUP 1
		}   
		# else is just invalid
		set PREVIOUSC 0
	    } else {
		## click is not
		if {[expr ([string length $STRMOVE] > 0)]} { 
		    # It means that it is the end of a jump		    
		    set STRMOVE "$STRMOVE[charCol $PREVIOUSJ]$PREVIOUSI"
		    set FINCOUP 1
		}   
		# else is just invalid
		set PREVIOUSC $coup
	    }
	} else {
	    ### This only is a move
	    set yo [IsJump $PREVIOUSI $PREVIOUSJ $i $j]
	    set valid 1
	    if {[expr ( (([ABS $PREVIOUSC] == 1) && ($yo <=2)) || ([ABS $PREVIOUSC] == 2) ) ] } { 
		## Checks whether (Pawn and close jump) or (Queen)
		
		if {[expr ($yo > 0)]} {
		    # is a jump
		    # eaten is opposite direction of the jump
		    #  1 XX  2
		    # XX    XX
		    # -2 XX -1
		    set dir [WhichDir $PREVIOUSI $PREVIOUSJ $i $j]
		    switch -- $dir {
			1 { set x [expr $i-$yo]; set y [expr $j+$yo]}
			2 { set x [expr $i-$yo]; set y  [expr $j-$yo]}
			-1 { set x [expr $i+$yo]; set y  [expr $j-$yo]}
			-2 { set x [expr $i+$yo]; set y  [expr $j+$yo]}
		    }
		    set yakekchos [isfull $x $y]
		    if {[expr ($yakekchos && [arenemies $yakekchos $PREVIOUSC])]} { 
			# jump is over ennemy
			setState $x $y 0
		    } else {
			# jump is over friend or nothing
			set valid 0 
		    }
		} else {
		    if {[expr ([string length $STRMOVE] > 0)]} {
			# was a jump so now only jumps are valid !
			set valid 0
			set STRMOVE "$STRMOVE[charCol $PREVIOUSJ]$PREVIOUSI"
			set PREVIOUSC 0
			set FINCOUP 1
		    }
		}

		if {$valid} {
		    setState $PREVIOUSI $PREVIOUSJ 0
		    if {[expr (($PREVIOUSC == 1) && ($i == 9))]} {
			## Make white Queen
			setState $i $j 2
		    } else {
			if {[expr (($PREVIOUSC == -1) && ($i == 0))]} {
			    ## Make black Queen
			    setState $i $j -2
			} else {
			    ## Put Pawn there in data Structure
			    setState $i $j $PREVIOUSC
			}
		    }
		    if {$yo} then {
			## Is jump so store first position, next will 
			## write followings
			set STRMOVE "$STRMOVE[charCol $PREVIOUSJ]$PREVIOUSI"
			.plateau.r$i.b$i$j configure -background [PressedBG]
		    } else {
			## No jump: just write begin and end positions
			set STRMOVE "[charCol $PREVIOUSJ]$PREVIOUSI[charCol $j]$i"
			set PREVIOUSC $coup
			set FINCOUP 1
		    }
		} else {
		    ## Not a valid click
		    .plateau.r$i.b$i$j configure -background [ButtonBG]
		    .plateau.r$PREVIOUSI.b$PREVIOUSI$PREVIOUSJ configure -background [ButtonBG]
		    set FINCOUP 1
		    set PREVIOUSC 0
		}
	    } else {
		## Not a valid click
		.plateau.r$PREVIOUSI.b$PREVIOUSI$PREVIOUSJ configure -background [ButtonBG]
		set PREVIOUSC $coup
	    }
	}
    } else {
	## Previous was occupied a new also : not a valid click
	if {[expr $coup != 0]} {
	    .plateau.r$i.b$i$j configure -background [PressedBG]
	}
	set PREVIOUSC $coup
    }
    set PREVIOUSI $i
    set PREVIOUSJ $j

    return $FINCOUP
}

# Testing whether a move (two positions) is a jump
proc IsJump {pi pj i j} {
    set mover [nState $pi $pj]
    if {[expr ( [ABS $mover] == 1 )]} {
	## isPawn
	set depx [ABS [expr $i - $pi] ]
	if {[expr $depx > 1]} {
#	    return $depx
	    return 1
	}
	set depy [ABS [expr $j - $pj] ]
	if {[expr $depy > 1]} {
	    return 1
#	    return $depx
	}
    } else {
# puts "pi : $pi, pj : $pj, i : $i, j : $j" 
	## isQueen
	set dirx [expr $i - $pi]
	set diry [expr $j - $pj]
	set absx [ABS $dirx]
	set absy [ABS $diry]
	if {[expr ($absx > 1) || ($absy > 1)]} {
	    set depx [expr ($dirx / $absx)]
	    set depy [expr ($diry / $absy)]

	    for {set factor 1} { [expr $factor < $absx] } {incr factor} {
		set ndepx [expr $depx * $factor]
		set ndepy [expr $depy * $factor]	
		set between [nState [expr $i-$ndepx] [expr $j-$ndepy]]
		if {[arenemies $mover $between]} {
		    return $factor
		} elseif {! [expr $between == 0]} {
		    ## Error jump over friend !!!
		    puts "Error jump over friend !!!"
		    return $factor
		}
	    }

	}
    }
    return 0
}

## Gives Jump direction
#  1 XX  2
# XX    XX
# -2 XX -1
proc WhichDir {pi pj i j} {
    set x [expr $i - $pi]
    set y [expr $j - $pj]
    if {[expr $x > 0]} {
	# Montant
	if {[expr $y > 0]} {
	    # vers gauche
	    return 2
	} else {
	    #vers droite
	    return 1
	}
   } else {
	# Descendant
	if {[expr $y > 0]} {
	    # vers gauche
	    return -1
	} else {
	    #vers droite
	    return -2
	}
    }    
} 

set EXTRA 20



## Convert integer to char
proc charCol {x} {
    return [string range "abcdefghij" $x $x]
}

## Convert char to integer
proc intCol {c} {
    return [string first $c "abcdefghij"]
}

proc WaitPlay {} {
    global PROG PLATEAU FILE JOUEUR ARGS nextmove

    ## Sends board to file
    DisplayGame $JOUEUR

    set GO [clock clicks]

    set nextmove [Execute $PROG($JOUEUR) $PLATEAU $ARGS($JOUEUR)]

    set END [clock clicks]
    set FILEID [open $FILE($JOUEUR) a 0666]
    puts $FILEID $nextmove 
    close $FILEID
    return [expr $END - $GO]
}


set OVER 0

## Next player
proc Next {} {

    set MAXNBCOUP 999
    global NBCOUPS
    if { [expr  ($NBCOUPS(1) > $MAXNBCOUP) && ($NBCOUPS(-1) > $MAXNBCOUP)]} {
	Quit "Max. Coups."; return
    }


    global OVER
    if {! $OVER} {


    global STRMOVE
    global LASTMOVE
    global COMPUTING
    global ORDI
    global JOUEUR
    global WHITES 
    global BLACKS
    set JOUEUR [expr -($JOUEUR)]

    if {[expr ($WHITES && $BLACKS)]} {
	## Not over


	## Computer game
	if {$ORDI} {
	    if {$ORDI != $JOUEUR} {
		set COMPUTING "analyse ..."

		## Write preceeding move
# 		if {[expr [string length $STRMOVE] > 0]} { Redirect $JOUEUR $STRMOVE }
		set LASTMOVE $STRMOVE
		set STRMOVE ""
		update idletasks

		
#		set TIMING [lindex [time WaitPlay] 0]
		set TIMING [WaitPlay]
		set COMPUTING "joue ..."    
		TreatTime $TIMING

		global nextmove
		set numcoup [string length $nextmove]
		set x 0
		set y 0
		set final 0
		for {set i 0} { [expr $i < $numcoup] } {incr i} {
		    ## sleep 1
		    set z 0; after 500 { set z 1 } ; vwait z
		    set y [intCol [string index $nextmove $i]]
		    if {[expr ($y < 0)]} { Quit "Arrt."; return }
		    incr i
		    set x [string index $nextmove $i]
		    if {! [string match {[0-9]} $x]} { Quit "Arrt."; return }
		    set final [Select $x $y ]
		    update idletasks
		}
		if {! $final} { 
		    ## Means that xboard is waiting for the same click 
		    ## to end jumping move
		    Select $x $y 
		}
		set COMPUTING ""    
		update idletasks
		TreatLate $TIMING
		Next 
	    } else {
		## Write preceeding move
		## but not to screen
		set LASTMOVE $STRMOVE
		set STRMOVE ""
		update idletasks
	    }
	} else {
	    ## Write preceeding move
# 	    if {[expr [string length $STRMOVE] > 0]} { Redirect $JOUEUR $STRMOVE  }
	    set LASTMOVE $STRMOVE
	    set STRMOVE ""
	    update idletasks
	}

    } else {
	## Is over
	Quit "Fin."
    }
}
}



proc Quit { msg } {
    global COMPUTING
    set COMPUTING $msg
    update idletasks
    global OVER 
    global WHITES BLACKS
    if {! $OVER} {
	if {[expr $WHITES > $BLACKS]} {
	    set OVER -1
	} else {
	   if {[expr $WHITES < $BLACKS]} {
	    set OVER 1
	   } else {
	       # Count queens
	       set queens 0
	       global lignes
	       for {set i 0} {$i < 10} {incr i} {
		   for {set j 0} {$j < 5} {incr j} {
		       if {[expr [ABS [lindex $lignes($i) $j]] == 2]} {
			   set queens [expr $queens + [lindex $lignes($i) $j]]
		       }
		   }
	       }
	       if {[expr $queens > 0]} {
		   set OVER -1
	       } else {
		   if {[expr $queens < 0]} {
		       set OVER 1
		   } else {
		       #late
		       global RETARD
		       set difflate [expr $RETARD(1) - $RETARD(-1)]
		       if {[expr $difflate > 0]} {
			   set OVER -1
		       } else {
			   if {[expr $difflate < 0]} {
			       set OVER 1
			   }
		       }
		   } 
	       }
	   }
	}
    }
    if {[expr $OVER == 1]} {
	puts "Partie termine. Vainqueur : NOIRS."
    } else {
	if {[expr $OVER == -1]} {
	    puts "Partie termine. Vainqueur : BLANCS."
	} else {
	    puts "Partie termine. galit."
	}
    } 	

}

set BIGLATE(1) 0
set BIGLATE(-1) 0

proc TreatTime { ltime } {
    global GLOBALTIME
    global GLOBALLAST
    global NBCOUPS
    global JOUEUR

    incr NBCOUPS($JOUEUR)
    set GLOBALLAST($JOUEUR) [expr $ltime / 1000000.0]
    set GLOBALTIME($JOUEUR) [expr $GLOBALTIME($JOUEUR) + [expr $ltime / 1000000.0] ]
}


proc TreatLate { ltime } {
    global ORDI
    if {[expr $ORDI == -2]} {

	global RETARD
	global MAXTIME
	global JOUEUR

	global BIGLATE
	set BIGFACTOR 3
	set BIGMAC    2
	set MAXRET    300
	set MAXDIFF   200
	
	if {[expr ($ltime> $MAXTIME($JOUEUR))]} {
	    incr RETARD($JOUEUR)
	    if {[expr ($ltime> [expr $BIGFACTOR * $MAXTIME($JOUEUR)])]} {
		incr BIGLATE($JOUEUR)
		if {[expr $BIGLATE($JOUEUR) > $BIGMAC]} {
		    global OVER; set OVER $JOUEUR
		    if {[expr $JOUEUR == 1]} {
			Quit "Blancs DISQ."; return 
		    } else {
			Quit "Noirs DISQ." ; return 
		    }
		}
	    }
	    if {[expr  ($RETARD($JOUEUR) > $MAXRET) || ($RETARD($JOUEUR) - $RETARD([expr - $JOUEUR]) > $MAXDIFF)  ]} {
		global OVER; set OVER $JOUEUR
		if {[expr $JOUEUR == 1]} {
		    Quit "Blancs DISQ." ; return 
		} else {
		    Quit "Noirs DISQ." ; return 
		}
	    }
	}
    }
}


Init
